//package com.yanzuoguang.cloud.aop;
//
//import com.alibaba.fastjson.JSON;
//import com.tourbida.sys.common.AbstractValidateAspect;
//import com.tourbida.sys.common.utils.ThreadNext;
//import com.tourbida.sys.core.Config;
//import com.tourbida.sys.core.cache.LocalCacheData;
//import com.tourbida.sys.core.util.JSONHelper;
//import com.tourbida.sys.core.util.Log;
//import com.tourbida.sys.core.util.ObjectHelper;
//import com.tourbida.sys.core.util.StringHelper;
//import com.tourbida.sys.feign.LogFeign;
//import com.tourbida.sys.vo.LogVo;
//import com.tourbida.sys.vo.ResponseResult;
//import com.tourbida.sys.vo.ResponseResultBuilder;
//import com.tourbida.sys.web.BaseController;
//import org.aspectj.lang.ProceedingJoinPoint;
//import org.aspectj.lang.Signature;
//import org.aspectj.lang.annotation.Around;
//import org.aspectj.lang.annotation.Aspect;
//import org.aspectj.lang.annotation.Pointcut;
//import org.aspectj.lang.reflect.MethodSignature;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.stereotype.Component;
//
//import javax.servlet.ServletRequest;
//import javax.servlet.ServletResponse;
//import java.lang.reflect.Method;
//import java.lang.reflect.Type;
//import java.util.concurrent.LinkedBlockingQueue;
//
///**
// * LogsAspect（接口请求日志切面）
// *
// * @author: Kang
// * @time: 2018年04月25日 11:43
// */
//@Aspect
//@Component
//public class WebAspect extends AbstractValidateAspect implements ThreadNext.Next {
//
//    private static final Logger logger = LoggerFactory.getLogger(WebAspect.class);
//
//    @Value("${spring.application.name}")
//    private String applicationName;
//
//    @Value("${config.logAll:false}")
//    private boolean logAll = false;
//
//    @Value("${config.cacheTime:120}")
//    private int cacheTime = 120;
//
//    private LogFeign logInterFeign;
//
//    /**
//     * 缓存队列
//     */
//    private volatile LinkedBlockingQueue<LogVo> cache = new LinkedBlockingQueue<LogVo>();
//
//    // 缓存的每次请求的结果
//    private LocalCacheData<RequestCacheResult> _cacheResult = new LocalCacheData<RequestCacheResult>(cacheTime);
//
//    public WebAspect() {
//        ThreadNext.start(logger, this, "save log error");
//    }
//
//    /**
//     * exec aop point aspect
//     */
//    @Pointcut("execution(* com.tourbida..web..*(..))")
//    public void webAspect() {
//    }
//
//    /**
//     * 获取返回的至类型
//     *
//     * @param joinPoint
//     * @return
//     * @throws NoSuchMethodException
//     */
//    private Type getReturnType(ProceedingJoinPoint joinPoint) {
//        //获取返回值类型
//        Signature s = joinPoint.getSignature();
//        MethodSignature ms = (MethodSignature) s;
//        Method m = ms.getMethod();
//        Type t = m.getAnnotatedReturnType().getType();
//        return t;
//    }
//
//    /**
//     * 执行环形切面
//     *
//     * @param joinPoint
//     * @return
//     */
//    @Around(value = "webAspect()")
//    public Object requestWebAround(ProceedingJoinPoint joinPoint) throws Throwable {
//        Log.threadBegin();
//        ResponseResult responseResult = null;           // 用户数据库记录
//        long start = System.currentTimeMillis();
//        String name = joinPoint.getSignature().getName();
//        try {
//            logger.info("=================[ {} ] request params is {} =================", name, joinPoint.getArgs());
//            Object result = executeMethod(joinPoint, name);
//            if (result instanceof ResponseResult) {
//                responseResult = (ResponseResult) result;
//            } else {
//                responseResult = ResponseResult.result(result);
//            }
//            return result;
//        } catch (Exception e) {
//            responseResult = BaseController.getError(logger, "=================[ " + name + " ] is error {} =================", e);
//            if (getReturnType(joinPoint).getTypeName().indexOf(ResponseResult.class.getName()) > -1) {
//                return responseResult;
//            } else {
//                throw e;
//            }
//        } finally {
//            long end = System.currentTimeMillis();
//            Log.threadCommit();
//            saveInterLogs(joinPoint, responseResult);
//            logger.info("=================[ {} ] time ({})ms, result is {} =================", name, (end - start), responseResult);
//        }
//    }
//
//    private Object executeMethod(ProceedingJoinPoint joinPoint, String name) throws Throwable {
//        if (joinPoint.getArgs().length != 1
//                || joinPoint.getArgs().length == 1 &&
//                (joinPoint.getArgs()[0] instanceof ServletResponse || joinPoint.getArgs()[0] instanceof ServletRequest)
//                ) {
//            return joinPoint.proceed();
//        } else {
//            // 获取请求编号
//            Object firstArgs = joinPoint.getArgs().length > 0 ? joinPoint.getArgs()[0] : null;
//            String reqId = StringHelper.GetLastString(
//                    ObjectHelper.GetString(firstArgs, "__req"),
//                    ObjectHelper.GetString(firstArgs, "reqId"),
//                    ObjectHelper.GetString(firstArgs, "repeatCode"),
//                    ObjectHelper.GetString(firstArgs, "thirdOrderId")
//            );
//            if (StringHelper.IsEmpty(reqId)) {
//                reqId = StringHelper.md5(JSONHelper.SerializeObject(firstArgs));
//            } else {
//                // 请求编号和公司编号挂钩
//                reqId = StringHelper.GetID(ObjectHelper.GetString(firstArgs, "companyId"), reqId);
//            }
//            String reqFull = StringHelper.GetID(reqId, getHttpRequestUrl());
//            RequestCacheResult req = _cacheResult.get(reqFull, new RequestCacheResult(reqFull));
//            // 缓存的键值对
//            if (req.getResult() == null) {
//                synchronized (req) {
//                    if (req.getResult() == null) {
//                        try {
//                            req.setResult(joinPoint.proceed());
//                        } catch (Exception ex) {
//                            req.setResult(ex);
//                        }
//                    }
//                }
//            }
//            Object result = req.getResult();
//            if (result instanceof Throwable) {
//                throw (Throwable) result;
//            }
//            return result;
//        }
//    }
//
//    /**
//     * deal with inter api logs
//     *
//     * @param joinPoint      请求参数
//     * @param responseResult 返回参数
//     */
//    private void saveInterLogs(ProceedingJoinPoint joinPoint, ResponseResult responseResult) {
//        // 日志请求不记录,防止死循环递归
//        if (applicationName.indexOf("log") >= 0) {
//            return;
//        }
//        // 正常请求不记录
//        if (!logAll && responseResult.getCode() == ResponseResultBuilder.SUCCESS) {
//            return;
//        }
//        LogVo logVo = initLogInterVo(getHttpRequestUrl(), joinPoint, responseResult);
//        addLog(logVo);
//    }
//
//    /**
//     * 添加日志到缓存中，并不是立即添加，而是通过线程执行，防止对环境造成影响
//     *
//     * @param logVo
//     */
//    public void addLog(LogVo logVo) {
//        cache.add(logVo);
//    }
//
//    /**
//     * 初始化日志Vo
//     *
//     * @param url            请求路径
//     * @param joinPoint      请求参数
//     * @param responseResult 返回参数
//     * @return
//     */
//    private LogVo initLogInterVo(String url, ProceedingJoinPoint joinPoint, ResponseResult responseResult) {
//        LogVo logInterVo = new LogVo();
//        logInterVo.setLogId(StringHelper.GetNewID());
//        logInterVo.setLogSources(applicationName);//平台名
//        logInterVo.setInterUrl(url);//请求URL
//        Object para = joinPoint.getArgs();
//        if (joinPoint.getArgs().length == 1) {
//            para = joinPoint.getArgs()[0];
//        }
//        logInterVo.setContent(JSON.toJSONString(para));//请求参数
//        logInterVo.setResult(JSON.toJSONString(responseResult));//返回参数
//        logInterVo.setStatus(responseResult.getCode() == ResponseResultBuilder.SUCCESS ? 1 : 0);
//        return logInterVo;
//    }
//
//    /**
//     * 执行下一个函数,出现异常会继续执行
//     *
//     * @return 是否继续执行
//     */
//    @Override
//    public boolean next() throws Exception {
//        while (cache.size() > 0) {
//            LogVo item = cache.poll();
//            if (item != null) {
//                if (logInterFeign == null) {
//                    logInterFeign = Config.Context.getBean(LogFeign.class);
//                }
//                logInterFeign.saveInterLogs(item);
//            }
//        }
//        return true;
//    }
//
//    /**
//     * 沉睡时间
//     *
//     * @return
//     */
//    @Override
//    public int getNextTime() {
//        return 1000;
//    }
//}
